%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% draw snapshots of the simulation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% draw the particles
plot(xp(1,:),xp(2,:),'ro','LineWidth',0.2,'MarkerEdgeColor','r', ...
    'MarkerFaceColor','r','MarkerSize',2);
hold on; grid off;

% draw the grid cells
for i_g1=1:numelem % loop over the grid cells
    patch(x(1,conn(:,i_g1)),x(2,conn(:,i_g1)),'-','LineWidth',0.2, ...
        'FaceColor','none','EdgeColor','k');
end

% draw the particle domains
for i_g1=1:numpar  % loop over the particles
    if strcmp(interpolator,'MPM') || strcmp(interpolator,'uGIMP')
        ParVec1=InitParVec1(:,i_g1);
        ParVec2=InitParVec2(:,i_g1);
    elseif strcmp(interpolator,'cpGIMP')
        ParVec1=[F(1,1,i_g1)*InitParVec1(1,i_g1);0];
        ParVec2=[0;F(2,2,i_g1)*InitParVec2(2,i_g1)];
    elseif strcmp(interpolator,'CPDI')
        % update two vectors defining the particle domain
        ParVec1=F(:,:,i_g1)*InitParVec1(:,i_g1);
        ParVec2=F(:,:,i_g1)*InitParVec2(:,i_g1);
    end
    % calculate the coordinates of 4 corners of the particle domain
    xEx=zeros(2,4);
    xEx(:,1)=[xp(1,i_g1)-ParVec1(1)-ParVec2(1);xp(2,i_g1)-ParVec1(2)-ParVec2(2)];
    xEx(:,2)=[xp(1,i_g1)+ParVec1(1)-ParVec2(1);xp(2,i_g1)+ParVec1(2)-ParVec2(2)];
    xEx(:,3)=[xp(1,i_g1)+ParVec1(1)+ParVec2(1);xp(2,i_g1)+ParVec1(2)+ParVec2(2)];
    xEx(:,4)=[xp(1,i_g1)-ParVec1(1)+ParVec2(1);xp(2,i_g1)-ParVec1(2)+ParVec2(2)];
    % draw the particle domain
    patch(xEx(1,:),xEx(2,:),'-','LineWidth',0.5,'FaceColor','none','EdgeColor','b');
end

axis equal;